<!DOCTYPE HTML>
<html>
    <head>

        <!-- Mobile Responsive Meta Tag -->
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

        <!-- width=device-width = width of the webpage will based on device width -->
        <!-- initial-scale=1 = assures are device are initally zoomed at 100% -->
        <!-- with shrink-to-fit=no avoid vw becomes more realistic based on the device size  -->

        <!-- Bootstrap Link -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>

        <!-- Custom CSS -->
        <!-- <link rel="stylesheet" href="index.css"> -->

        <title>Bootstrap Grid System</title>

    </head>
    <body class="text-center">

        <h1>Bootstrap Grid System</h1>

        <!-- Two Columns Start-->
        <h2>Two Columns</h2>
        <div class="container-fluid">

            <!--Row with two equal columns-->
            <h3>1:1 Ratio</h3>

            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-6">6 Col</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-6">6 Col</div>
            </div>
            
            <!--Row with two columns divided in 1:2 ratio-->
            <h3>1:2 Ratio</h3>

            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-4">4 Col</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-8">8 Col</div>
            </div>
            
            <!--Row with two columns divided in 1:3 ratio-->
            <h3>1:3 Ratio</h3>

            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-3">3 Col</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-9">9 Col</div>
            </div>

        </div>
        <!-- Two Columns End-->

        <!-- Three Columns Start -->
        <h2>Three Columns</h2>
        <div class="container-fluid">

            <!--Row with three equal columns-->
            <h3>1:1:1 Ratio</h3>

            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-4">4 Col</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-4">4 Col</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col-4">4 Col</div>
            </div>
            
            <!--Row with three columns divided in 1:2:1 ratio-->
            <h3>1:2:1 Ratio</h3>

            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-3">3 Col</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-6">6 Col</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col-3">3 Col</div>
            </div>
            
            <!--Row with three columns divided in an uneven ratio-->
            <h3>Uneven Ratio</h3>

            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-3">3 Col</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-7">7 Col</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col-2">2 Col</div>
            </div>

        </div>
        
        <!-- Three Columns End-->

        <!-- Automatic Sizing Start -->
        <h2>Automatic Sizing</h2>
        <div class="container-fluid">
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col">Auto</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col">Auto</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col">Auto</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col">Auto</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col">Auto</div>
            </div>
        </div>
        <!-- Automatic Sizing End -->

        <!-- Mobile Responsive Columns Start -->
        <h2>Mobile Responsive Columns</h2>
        <div class="container-fluid">
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-sm-6 col-md-4 col-lg-2">Responsive</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-sm-6 col-md-8 col-lg-10">Responsive</div>
            </div>
        </div>
        <!-- Mobile Responsive Columns End -->

        <!-- Multi-Column Layouts Start -->
        <!-- What happens if we have more than 12 columns occupied in one row? -->
        <h2>Multi-Column Layouts</h2>
        <div class="container-fluid">
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-4">Catalog 1</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-4">Catalog 2</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col-4">Catalog 3</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col-4">Catalog 4</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-4">Catalog 5</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col-4">Catalog 6</div>
            </div>
        </div>
        <!-- Multi-Column Layouts End -->

        <!-- Offsetting Columns Start -->
        <!-- We can move our element to another container using offset -->
        <h2>Offsetting Columns</h2>
        <div class="container-fluid">
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark offset-2 col-6  ">Offset Column</div>
                <div class="bg-primary pt-3 pb-3 border border-dark offset-3 col-6 ">Offset Column</div>
                <div class="bg-primary pt-3 pb-3 border border-dark offset-4 col-6 ">Offset Column</div>
            </div>
        </div>

        

        <!-- Offsetting Columns End -->
        
        <!-- Column Orders Start -->
        <h2>Column Orders</h2>
        <div class="container-fluid">
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col order-2 order-md-1">Left</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col order-1 order-md-2">Right</div>
            </div>
        </div>
        <!-- Column Orders End -->



        <!-- Additional codes -->
        <!-- Responsive columns to different displays:  -->
        <hr>
        <h3>Responsive columns to different displays</h3>
        <!-- 
            class to take note:
            col-sm-# : for small to larges (also same as col-#)
            col-md-# : for medium to large devices
            col-lg-# : for large devices
         -->
        <div class="container-fluid">
            <h3>Example 1</h3>
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-sm-12 col-md-6">12 columns if small device, 6 columns if medium or large device</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-sm-12 col-md-6">12 columns if small device, 6 columns if medium or large device</div>
            </div>

            <h3>Example 2</h3>
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-sm-12 col-md-6 col-lg-5">12 columns if small device, 6 columns if medium, and 3 colums if large device</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-sm-12 col-md-6 col-lg-5">12 columns if small device, 6 columns if medium, and 3 colums if large device</div>
            </div>


            <h3>Example 3</h3>
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-sm-12 col-md-4">12 columns if small device, 4 colums if medium or large device</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-sm-12 col-md-4">12 columns if small device, 4 colums if medium or large device</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col-sm-12 col-md-4">12 columns if small device, 4 colums if medium or large device</div>
            </div>


            <h3>Example 4</h3>
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col-12 col-md-4 col-lg-3">12 columns if small device, 4 colums if medium device, 3 colums if large device</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col-12 col-md-4 col-lg-3">12 columns if small device, 4 colums if medium device, 3 colums if large device</div>
                <div class="bg-primary pt-3 pb-3 border border-dark col-12 col-md-4 col-lg-3">12 columns if small device, 4 colums if medium device, 3 colums if large device</div>
            </div>

        </div>

        <hr>
        <!-- Responsive element orders based on device size -->
        <h2>Responsive orders to device size</h2>
        <div class="container-fluid">

            <h3>Example 1</h3>
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col order-sm-2 order-md-1">This one will be on right if small device, and will be on left if medium or large device</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col order-sm-1 order-md-2">This one will be on left if small device, and will be on right if medium or large device</div>
            </div>


            <h3>Example 2</h3>
            <div class="text-light row">
                <div class="bg-primary pt-3 pb-3 border border-dark col order-sm-1 order-md-2 order-lg-3">a</div>
                <div class="bg-secondary pt-3 pb-3 border border-dark col order-sm-2 order-md-1 order-lg-2">b</div>
                <div class="bg-success pt-3 pb-3 border border-dark col order-sm-3 order-md-3 order-lg-1" >c</div>
            </div>
            <p>Example orders in different device</p>
            <p><strong>Small device: </strong>a,b,c || 
                <strong>Medium device: </strong>b,a,c ||
                <strong>Large device: </strong>c,b,a
            </p>
        

        </div>
        <!-- Column Orders End -->



        <!-- Bootstrap Script -->
        <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>

    </body>
</html>
